## openttd 13.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

if(NOT BINARY_NAME)
    set(BINARY_NAME openttd)
endif()

project(${BINARY_NAME}
    VERSION 13.0
)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
    message(FATAL_ERROR "In-source builds not allowed. Please run \"cmake ..\" from the build directory. You may need to delete \"${CMAKE_SOURCE_DIR}/CMakeCache.txt\" first.")
endif()

# Debug mode by default.
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug)
endif()

if (EMSCRIPTEN)
    set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/os/emscripten/cmake")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")
set(CMAKE_OSX_DEPLOYMENT_TARGET 10.13)

# Use GNUInstallDirs to allow customisation
# but set our own default data and bin dir
if(NOT CMAKE_INSTALL_DATADIR)
    set(CMAKE_INSTALL_DATADIR "share/games")
endif()
if(NOT CMAKE_INSTALL_BINDIR)
    set(CMAKE_INSTALL_BINDIR "games")
endif()
include(GNUInstallDirs)

include(Options)
set_options()
set_directory_options()

include(Static)
set_static_if_needed()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED YES)
set(CMAKE_CXX_EXTENSIONS NO)

set(CMAKE_EXPORT_COMPILE_COMMANDS YES)

# An empty target for the tools
add_custom_target(tools)

include(Endian)
add_endian_definition()

include(CompileFlags)
compile_flags()

if(APPLE OR UNIX)
    add_definitions(-DUNIX)
endif()

if(UNIX)
    find_package(Doxygen)
endif()

list(APPEND GENERATED_SOURCE_FILES "${CMAKE_BINARY_DIR}/generated/rev.cpp")
if(WIN32)
    list(APPEND GENERATED_SOURCE_FILES "${CMAKE_BINARY_DIR}/generated/ottdres.rc")
endif()

# Generate a target to determine version, which is execute every 'make' run
add_custom_target(find_version
        ${CMAKE_COMMAND}
                -DFIND_VERSION_BINARY_DIR=${CMAKE_BINARY_DIR}/generated
                -DCPACK_BINARY_DIR=${CMAKE_BINARY_DIR}
                -DREV_MAJOR=${PROJECT_VERSION_MAJOR}
                -DREV_MINOR=${PROJECT_VERSION_MINOR}
                -DWINDOWS=${WIN32}
                -P "${CMAKE_SOURCE_DIR}/cmake/scripts/FindVersion.cmake"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        BYPRODUCTS ${GENERATED_SOURCE_FILES}
)

# Documentation
if(DOXYGEN_EXECUTABLE)
    add_custom_target(docs)
    add_custom_target(docs_source
        ${CMAKE_COMMAND} -E make_directory ${CMAKE_BINARY_DIR}/docs
        COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        COMMENT "Generating documentation for source"
    )
    add_dependencies(docs_source
        find_version
    )
    add_dependencies(docs
        docs_source
    )
endif()

include(AddCustomXXXTimestamp)

if(OPTION_TOOLS_ONLY)
    if(HOST_BINARY_DIR)
        unset(HOST_BINARY_DIR CACHE)
    endif()
    add_subdirectory(${CMAKE_SOURCE_DIR}/src)
    return()
endif()

if(APPLE)
	# Avoid searching for headers in Frameworks, and libraries in LIBDIR.
	set(CMAKE_FIND_FRAMEWORK LAST)
endif()

# Prefer -pthread over -lpthread, which is often the better option of the two.
set(CMAKE_THREAD_PREFER_PTHREAD YES)
# Make sure we have Threads available.
find_package(Threads REQUIRED)

find_package(ZLIB)
find_package(LibLZMA)
find_package(LZO)
find_package(PNG)

if(NOT OPTION_DEDICATED)
    if(NOT WIN32)
        find_package(Allegro)
        if(NOT APPLE)
            find_package(Freetype)
            find_package(SDL2)
            if(NOT SDL2_FOUND)
                find_package(SDL)
            endif()
            find_package(Fluidsynth)
            find_package(Fontconfig)
            find_package(ICU OPTIONAL_COMPONENTS i18n lx)
        endif()
    endif()
endif()
if(APPLE)
    find_package(Iconv)

    find_library(AUDIOTOOLBOX_LIBRARY AudioToolbox)
    find_library(AUDIOUNIT_LIBRARY AudioUnit)
    find_library(COCOA_LIBRARY Cocoa)
    find_library(QUARTZCORE_LIBRARY QuartzCore)
endif()

if(NOT EMSCRIPTEN AND NOT OPTION_DEDICATED)
    find_package(OpenGL COMPONENTS OpenGL)
endif()

if(MSVC)
    find_package(Editbin REQUIRED)
endif()

find_package(SSE)
find_package(Xaudio2)

find_package(Grfcodec)

include(CheckIPOSupported)
check_ipo_supported(RESULT IPO_FOUND)

show_options()

if(UNIX AND NOT APPLE AND NOT OPTION_DEDICATED)
    if(NOT SDL_FOUND AND NOT SDL2_FOUND AND NOT ALLEGRO_FOUND)
        message(FATAL_ERROR "SDL, SDL2 or Allegro is required for this platform")
    endif()
endif()
if(APPLE)
    if(NOT AUDIOTOOLBOX_LIBRARY)
        message(FATAL_ERROR "AudioToolbox is required for this platform")
    endif()
    if(NOT AUDIOUNIT_LIBRARY)
        message(FATAL_ERROR "AudioUnit is required for this platform")
    endif()
    if(NOT COCOA_LIBRARY)
        message(FATAL_ERROR "Cocoa is required for this platform")
    endif()
    if(NOT QUARTZCORE_LIBRARY)
        message(FATAL_ERROR "QuartzCore is required for this platform")
    endif()
endif()

if(OPTION_PACKAGE_DEPENDENCIES)
    if(NOT UNIX)
        message(FATAL_ERROR "Can only package dependencies on Linux")
    endif()
    if(OPTION_INSTALL_FHS)
        message(FATAL_ERROR "Cannot install in FHS folders when we are packaging dependencies")
    endif()
    if(${CMAKE_VERSION} VERSION_LESS "3.16.0")
        message(FATAL_ERROR "OPTION_PACKAGE_DEPENDENCIES can only work with CMake 3.16+; you are using ${CMAKE_VERSION}")
    endif()

    # If we are packaging dependencies, we do two things:
    # 1) set the RPATH to include $ORIGIN/lib; $ORIGIN (that literal string)
    #    is a Linux indicator for "path where application is". In CMake, we
    #    have to do this before add_executable() is executed.
    # 2) copy the libraries that we compile against to the "lib" folder.
    #    This is done in InstallAndPackage.cmake.
    set(CMAKE_INSTALL_RPATH "\$ORIGIN/lib")
    set(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
endif()

include(SourceList)

# Needed by rev.cpp
include_directories(${CMAKE_SOURCE_DIR}/src)
# Needed by everything that uses Squirrel
include_directories(${CMAKE_SOURCE_DIR}/src/3rdparty/squirrel/include)

include(MSVCFilters)

add_executable(openttd WIN32 ${GENERATED_SOURCE_FILES})
set_target_properties(openttd PROPERTIES OUTPUT_NAME "${BINARY_NAME}")
# All other files are added via target_sources()

if(MSVC)
    # Add DPI manifest to project; other WIN32 targets get this via ottdres.rc
    target_sources(openttd PRIVATE "${CMAKE_SOURCE_DIR}/os/windows/openttd.manifest")
endif()

add_subdirectory(${CMAKE_SOURCE_DIR}/bin)
add_subdirectory(${CMAKE_SOURCE_DIR}/src)
add_subdirectory(${CMAKE_SOURCE_DIR}/media)

add_dependencies(openttd
    find_version)

target_link_libraries(openttd
    openttd::languages
    openttd::settings
    openttd::media
    openttd::basesets
    openttd::script_api
    Threads::Threads
)

if(HAIKU)
    target_link_libraries(openttd "be" "network" "midi")
endif()

if(IPO_FOUND)
    set_target_properties(openttd PROPERTIES INTERPROCEDURAL_OPTIMIZATION_RELEASE True)
    set_target_properties(openttd PROPERTIES INTERPROCEDURAL_OPTIMIZATION_MINSIZEREL True)
    set_target_properties(openttd PROPERTIES INTERPROCEDURAL_OPTIMIZATION_RELWITHDEBINFO True)
endif()
set_target_properties(openttd PROPERTIES VS_DEBUGGER_WORKING_DIRECTORY "${CMAKE_BINARY_DIR}")
process_compile_flags()

include(LinkPackage)
link_package(PNG TARGET PNG::PNG ENCOURAGED)
link_package(ZLIB TARGET ZLIB::ZLIB ENCOURAGED)
link_package(LIBLZMA TARGET LibLZMA::LibLZMA ENCOURAGED)
link_package(LZO)

if(NOT OPTION_DEDICATED)
    link_package(Fluidsynth)
    link_package(SDL)
    link_package(SDL2 TARGET SDL2::SDL2)
    link_package(Allegro)
    link_package(FREETYPE TARGET Freetype::Freetype)
    link_package(Fontconfig TARGET Fontconfig::Fontconfig)
    link_package(ICU_lx)
    link_package(ICU_i18n)

    if(SDL2_FOUND AND OPENGL_FOUND AND UNIX)
        # SDL2 dynamically loads OpenGL if needed, so do not link to OpenGL when
        # on Linux. For Windows, we need to link to OpenGL as we also have a win32
        # driver using it.
        add_definitions(-DWITH_OPENGL)
        message(STATUS "OpenGL found -- -DWITH_OPENGL -- (via SDL2)")
    else()
        link_package(OpenGL TARGET OpenGL::GL)
    endif()
endif()

if(APPLE)
    link_package(Iconv TARGET Iconv::Iconv)

    target_link_libraries(openttd
        ${AUDIOTOOLBOX_LIBRARY}
        ${AUDIOUNIT_LIBRARY}
        ${COCOA_LIBRARY}
        ${QUARTZCORE_LIBRARY}
    )

    add_definitions(
        -DWITH_COCOA
    )
endif()

if(EMSCRIPTEN)
    add_library(WASM::WASM INTERFACE IMPORTED)

    # Allow heap-growth, and start with a bigger memory size.
    target_link_libraries(WASM::WASM INTERFACE "-s ALLOW_MEMORY_GROWTH=1")
    target_link_libraries(WASM::WASM INTERFACE "-s INITIAL_MEMORY=33554432")
    target_link_libraries(WASM::WASM INTERFACE "-s DISABLE_EXCEPTION_CATCHING=0")
    add_definitions(-s DISABLE_EXCEPTION_CATCHING=0)

    # Export functions to Javascript.
    target_link_libraries(WASM::WASM INTERFACE "-s EXPORTED_FUNCTIONS='[\"_main\", \"_em_openttd_add_server\"]' -s EXPORTED_RUNTIME_METHODS='[\"cwrap\"]'")

    # Preload all the files we generate during build.
    # As we do not compile with FreeType / FontConfig, we also have no way to
    # render several languages (like Chinese, ..), so where do you draw the
    # line what languages to include and which not? In the end, especially as
    # the more languages you add the slower downloading becomes, we decided to
    # only ship the English language.
    target_link_libraries(WASM::WASM INTERFACE "--preload-file ${CMAKE_BINARY_DIR}/baseset@/baseset")
    target_link_libraries(WASM::WASM INTERFACE "--preload-file ${CMAKE_BINARY_DIR}/lang/english.lng@/lang/english.lng")
    target_link_libraries(WASM::WASM INTERFACE "--preload-file ${CMAKE_SOURCE_DIR}/bin/ai@/ai")
    target_link_libraries(WASM::WASM INTERFACE "--preload-file ${CMAKE_SOURCE_DIR}/bin/game@/game")

    # We use IDBFS for persistent storage.
    target_link_libraries(WASM::WASM INTERFACE "-lidbfs.js")

    # Use custom pre-js and shell.html.
    target_link_libraries(WASM::WASM INTERFACE "--pre-js ${CMAKE_SOURCE_DIR}/os/emscripten/pre.js")
    target_link_libraries(WASM::WASM INTERFACE "--shell-file ${CMAKE_SOURCE_DIR}/os/emscripten/shell.html")

    # Build the .html (which builds the .js, .wasm, and .data too).
    set_target_properties(openttd PROPERTIES SUFFIX ".html")
    target_link_libraries(openttd WASM::WASM)
endif()

if(NOT PERSONAL_DIR STREQUAL "(not set)")
    add_definitions(
        -DWITH_PERSONAL_DIR
        -DPERSONAL_DIR="${PERSONAL_DIR}"
    )
endif()

if(NOT SHARED_DIR STREQUAL "(not set)")
    add_definitions(
        -DWITH_SHARED_DIR
        -DSHARED_DIR="${SHARED_DIR}"
    )
endif()

if(NOT GLOBAL_DIR STREQUAL "(not set)")
    add_definitions(
        -DGLOBAL_DATA_DIR="${GLOBAL_DIR}"
    )
endif()

link_package(SSE)

add_definitions_based_on_options()

if(WIN32)
    add_definitions(
        -DUNICODE
        -D_UNICODE
        -DWITH_UNISCRIBE
        -DPSAPI_VERSION=1
    )

    target_link_libraries(openttd
        ws2_32
        winmm
        imm32
        usp10
        psapi
    )
endif()

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    add_definitions(-DPOINTER_IS_64BIT)
endif()

include(CreateRegression)
create_regression()

if(APPLE OR WIN32)
    find_package(Pandoc)
endif()

include(InstallAndPackage)

=== src/CMakeLists.txt ===
add_subdirectory(script)
add_subdirectory(settingsgen)
add_subdirectory(strgen)

if(OPTION_TOOLS_ONLY)
    return()
endif()

add_subdirectory(3rdparty)
add_subdirectory(ai)
add_subdirectory(blitter)
add_subdirectory(core)
add_subdirectory(fontcache)
add_subdirectory(game)
add_subdirectory(lang)
add_subdirectory(linkgraph)
add_subdirectory(misc)
add_subdirectory(music)
add_subdirectory(network)
add_subdirectory(os)
add_subdirectory(pathfinder)
add_subdirectory(saveload)
add_subdirectory(sound)
add_subdirectory(spriteloader)
add_subdirectory(table)
add_subdirectory(video)
add_subdirectory(widgets)

add_files(
    viewport_sprite_sorter_sse4.cpp
    CONDITION SSE_FOUND
)

add_files(
    aircraft.h
    aircraft_cmd.cpp
    aircraft_cmd.h
    aircraft_gui.cpp
    airport.cpp
    airport.h
    airport_cmd.h
    airport_gui.cpp
    animated_tile.cpp
    animated_tile_func.h
    articulated_vehicles.cpp
    articulated_vehicles.h
    autoreplace.cpp
    autoreplace_base.h
    autoreplace_cmd.cpp
    autoreplace_cmd.h
    autoreplace_func.h
    autoreplace_gui.cpp
    autoreplace_gui.h
    autoreplace_type.h
    autoslope.h
    base_consist.cpp
    base_consist.h
    base_media_base.h
    base_media_func.h
    base_station_base.h
    bitmap_type.h
    bmp.cpp
    bmp.h
    bootstrap_gui.cpp
    bridge.h
    bridge_gui.cpp
    bridge_map.cpp
    bridge_map.h
    build_vehicle_gui.cpp
    cargo_type.h
    cargoaction.cpp
    cargoaction.h
    cargomonitor.cpp
    cargomonitor.h
    cargopacket.cpp
    cargopacket.h
    cargotype.cpp
    cargotype.h
    cheat.cpp
    cheat_func.h
    cheat_gui.cpp
    cheat_type.h
    clear_cmd.cpp
    clear_func.h
    clear_map.h
    command.cpp
    command_func.h
    command_type.h
    company_base.h
    company_cmd.cpp
    company_cmd.h
    company_func.h
    company_gui.cpp
    company_gui.h
    company_manager_face.h
    company_type.h
    console.cpp
    console_cmds.cpp
    console_func.h
    console_gui.cpp
    console_gui.h
    console_internal.h
    console_type.h
    cpu.cpp
    cpu.h
    crashlog.cpp
    crashlog.h
    currency.cpp
    currency.h
    date.cpp
    date_func.h
    date_gui.cpp
    date_gui.h
    date_type.h
    debug.cpp
    debug.h
    dedicated.cpp
    depot.cpp
    depot_base.h
    depot_cmd.cpp
    depot_cmd.h
    depot_func.h
    depot_gui.cpp
    depot_map.h
    depot_type.h
    direction_func.h
    direction_type.h
    disaster_vehicle.cpp
    disaster_vehicle.h
    dock_cmd.h
    dock_gui.cpp
    driver.cpp
    driver.h
    economy.cpp
    economy_base.h
    economy_cmd.h
    economy_func.h
    economy_type.h
    effectvehicle.cpp
    effectvehicle_base.h
    effectvehicle_func.h
    elrail.cpp
    elrail_func.h
    engine.cpp
    engine_base.h
    engine_cmd.h
    engine_func.h
    engine_gui.cpp
    engine_gui.h
    engine_type.h
    error.h
    error_gui.cpp
    fileio.cpp
    fileio_func.h
    fileio_type.h
    fios.cpp
    fios.h
    fios_gui.cpp
    fontcache.cpp
    fontcache.h
    fontdetection.h
    framerate_gui.cpp
    framerate_type.h
    gamelog.cpp
    gamelog.h
    gamelog_internal.h
    genworld.cpp
    genworld.h
    genworld_gui.cpp
    gfx.cpp
    gfx_func.h
    gfx_layout.cpp
    gfx_layout.h
    gfx_type.h
    gfxinit.cpp
    gfxinit.h
    goal.cpp
    goal_base.h
    goal_cmd.h
    goal_gui.cpp
    goal_type.h
    graph_gui.cpp
    graph_gui.h
    ground_vehicle.cpp
    ground_vehicle.hpp
    group.h
    group_cmd.cpp
    group_cmd.h
    group_gui.cpp
    group_gui.h
    group_type.h
    gui.h
    guitimer_func.h
    heightmap.cpp
    heightmap.h
    highscore.cpp
    highscore.h
    highscore_gui.cpp
    hotkeys.cpp
    hotkeys.h
    house.h
    house_type.h
    industry.h
    industry_cmd.cpp
    industry_cmd.h
    industry_gui.cpp
    industry_map.h
    industry_type.h
    industrytype.h
    ini.cpp
    ini_load.cpp
    ini_type.h
    intro_gui.cpp
    landscape.cpp
    landscape.h
    landscape_cmd.h
    landscape_type.h
    language.h
    league_base.h
    league_cmd.h
    league_cmd.cpp
    league_gui.h
    league_gui.cpp
    league_type.h
    livery.h
    main_gui.cpp
    map.cpp
    map_func.h
    map_type.h
    misc.cpp
    misc_cmd.cpp
    misc_cmd.h
    misc_gui.cpp
    mixer.cpp
    mixer.h
    music.cpp
    music_gui.cpp
    newgrf.cpp
    newgrf.h
    newgrf_airport.cpp
    newgrf_airport.h
    newgrf_airporttiles.cpp
    newgrf_airporttiles.h
    newgrf_animation_base.h
    newgrf_animation_type.h
    newgrf_callbacks.h
    newgrf_canal.cpp
    newgrf_canal.h
    newgrf_cargo.cpp
    newgrf_cargo.h
    newgrf_class.h
    newgrf_class_func.h
    newgrf_commons.cpp
    newgrf_commons.h
    newgrf_config.cpp
    newgrf_config.h
    newgrf_debug.h
    newgrf_debug_gui.cpp
    newgrf_engine.cpp
    newgrf_engine.h
    newgrf_generic.cpp
    newgrf_generic.h
    newgrf_gui.cpp
    newgrf_house.cpp
    newgrf_house.h
    newgrf_industries.cpp
    newgrf_industries.h
    newgrf_industrytiles.cpp
    newgrf_industrytiles.h
    newgrf_object.cpp
    newgrf_object.h
    newgrf_profiling.cpp
    newgrf_profiling.h
    newgrf_properties.h
    newgrf_railtype.cpp
    newgrf_railtype.h
    newgrf_roadtype.cpp
    newgrf_roadtype.h
    newgrf_sound.cpp
    newgrf_sound.h
    newgrf_spritegroup.cpp
    newgrf_spritegroup.h
    newgrf_station.cpp
    newgrf_station.h
    newgrf_storage.cpp
    newgrf_storage.h
    newgrf_text.cpp
    newgrf_text.h
    newgrf_town.cpp
    newgrf_town.h
    newgrf_townname.cpp
    newgrf_townname.h
    news_cmd.h
    news_func.h
    news_gui.cpp
    news_gui.h
    news_type.h
    object.h
    object_base.h
    object_cmd.cpp
    object_cmd.h
    object_gui.cpp
    object_map.h
    object_type.h
    openttd.cpp
    openttd.h
    order_backup.cpp
    order_backup.h
    order_base.h
    order_cmd.cpp
    order_cmd.h
    order_func.h
    order_gui.cpp
    order_type.h
    osk_gui.cpp
    pbs.cpp
    pbs.h
    progress.cpp
    progress.h
    querystring_gui.h
    rail.cpp
    rail.h
    rail_cmd.cpp
    rail_cmd.h
    rail_gui.cpp
    rail_gui.h
    rail_map.h
    rail_type.h
    random_access_file.cpp
    random_access_file_type.h
    rev.h
    road.cpp
    road.h
    road_cmd.cpp
    road_cmd.h
    road_func.h
    road_gui.cpp
    road_gui.h
    road_internal.h
    road_map.cpp
    road_map.h
    road_type.h
    roadstop.cpp
    roadstop_base.h
    roadveh.h
    roadveh_cmd.cpp
    roadveh_cmd.h
    roadveh_gui.cpp
    safeguards.h
    screenshot_gui.cpp
    screenshot_gui.h
    screenshot.cpp
    screenshot.h
    settings.cpp
    settings_cmd.h
    settings_func.h
    settings_gui.cpp
    settings_gui.h
    settings_internal.h
    settings_table.h
    settings_table.cpp
    settings_type.h
    ship.h
    ship_cmd.cpp
    ship_cmd.h
    ship_gui.cpp
    signal.cpp
    signal_func.h
    signal_type.h
    signs.cpp
    signs_base.h
    signs_cmd.cpp
    signs_cmd.h
    signs_func.h
    signs_gui.cpp
    signs_type.h
    slope_func.h
    slope_type.h
    smallmap_gui.cpp
    smallmap_gui.h
    sortlist_type.h
    sound.cpp
    sound_func.h
    sound_type.h
    sprite.cpp
    sprite.h
    spritecache.cpp
    spritecache.h
    station.cpp
    station_base.h
    station_cmd.cpp
    station_cmd.h
    station_func.h
    station_gui.cpp
    station_gui.h
    station_kdtree.h
    station_map.h
    station_type.h
    statusbar_gui.cpp
    statusbar_gui.h
    stdafx.h
    story.cpp
    story_base.h
    story_cmd.h
    story_gui.cpp
    story_type.h
    strgen/strgen.h
    string.cpp
    string_base.h
    string_func.h
    string_type.h
    stringfilter.cpp
    stringfilter_type.h
    strings.cpp
    strings_func.h
    strings_type.h
    subsidy.cpp
    subsidy_base.h
    subsidy_cmd.h
    subsidy_func.h
    subsidy_gui.cpp
    subsidy_type.h
    tar_type.h
    terraform_cmd.cpp
    terraform_cmd.h
    terraform_gui.cpp
    terraform_gui.h
    textbuf.cpp
    textbuf_gui.h
    textbuf_type.h
    texteff.cpp
    texteff.hpp
    textfile_gui.cpp
    textfile_gui.h
    textfile_type.h
    tgp.cpp
    tgp.h
    thread.h
    tile_cmd.h
    tile_map.cpp
    tile_map.h
    tile_type.h
    tilearea.cpp
    tilearea_type.h
    tilehighlight_func.h
    tilehighlight_type.h
    tilematrix_type.hpp
    timetable.h
    timetable_cmd.cpp
    timetable_cmd.h
    timetable_gui.cpp
    toolbar_gui.cpp
    toolbar_gui.h
    town.h
    town_cmd.cpp
    town_cmd.h
    town_gui.cpp
    town_kdtree.h
    town_map.h
    town_type.h
    townname.cpp
    townname_func.h
    townname_type.h
    track_func.h
    track_type.h
    train.h
    train_cmd.cpp
    train_cmd.h
    train_gui.cpp
    transparency.h
    transparency_gui.cpp
    transparency_gui.h
    transport_type.h
    tree_cmd.cpp
    tree_cmd.h
    tree_gui.cpp
    tree_map.h
    tunnel_map.cpp
    tunnel_map.h
    tunnelbridge.h
    tunnelbridge_cmd.cpp
    tunnelbridge_cmd.h
    tunnelbridge_map.h
    vehicle.cpp
    vehicle_base.h
    vehicle_cmd.cpp
    vehicle_cmd.h
    vehicle_func.h
    vehicle_gui.cpp
    vehicle_gui.h
    vehicle_gui_base.h
    vehicle_type.h
    vehiclelist.cpp
    vehiclelist.h
    viewport.cpp
    viewport_cmd.h
    viewport_func.h
    viewport_gui.cpp
    viewport_kdtree.h
    viewport_sprite_sorter.h
    viewport_type.h
    void_cmd.cpp
    void_map.h
    walltime_func.h
    water.h
    water_cmd.cpp
    water_cmd.h
    water_map.h
    waypoint.cpp
    waypoint_base.h
    waypoint_cmd.cpp
    waypoint_cmd.h
    waypoint_func.h
    waypoint_gui.cpp
    widget.cpp
    widget_type.h
    window.cpp
    window_func.h
    window_gui.h
    window_type.h
    zoom_func.h
    zoom_type.h
)

=== src/linkgraph/CMakeLists.txt ===
add_files(
    demands.cpp
    demands.h
    flowmapper.cpp
    flowmapper.h
    init.h
    linkgraph.cpp
    linkgraph.h
    linkgraph_base.h
    linkgraph_gui.cpp
    linkgraph_gui.h
    linkgraph_type.h
    linkgraphjob.cpp
    linkgraphjob.h
    linkgraphjob_base.h
    linkgraphschedule.cpp
    linkgraphschedule.h
    mcf.cpp
    mcf.h
    refresh.cpp
    refresh.h
)

=== src/music/CMakeLists.txt ===
if(NOT OPTION_DEDICATED)
    add_files(
        allegro_m.cpp
        allegro_m.h
        CONDITION Allegro_FOUND
    )

    add_files(
        fluidsynth.cpp
        fluidsynth.h
        CONDITION Fluidsynth_FOUND
    )

    add_files(
        cocoa_m.cpp
        cocoa_m.h
        CONDITION APPLE
    )

    add_files(
        dmusic.cpp
        dmusic.h
        win32_m.cpp
        win32_m.h
        CONDITION WIN32
    )

    add_files(
        extmidi.cpp
        extmidi.h
        CONDITION UNIX
    )

    add_files(
        bemidi.cpp
        bemidi.h
        CONDITION HAIKU
    )

    add_files(
        os2_m.cpp
        os2_m.h
        CONDITION OPTION_OS2
    )
endif()

add_files(
    midi.h
    midifile.cpp
    midifile.hpp
    music_driver.hpp
    null_m.cpp
    null_m.h
)

=== src/script/CMakeLists.txt ===
add_subdirectory(api)

if(OPTION_TOOLS_ONLY)
    return()
endif()

add_files(
    script_cmd.h
    script_config.cpp
    script_config.hpp
    script_fatalerror.hpp
    script_info.cpp
    script_info.hpp
    script_info_dummy.cpp
    script_instance.cpp
    script_instance.hpp
    script_scanner.cpp
    script_scanner.hpp
    script_storage.hpp
    script_suspend.hpp
    squirrel.cpp
    squirrel.hpp
    squirrel_class.hpp
    squirrel_helper.hpp
    squirrel_helper_type.hpp
    squirrel_std.cpp
    squirrel_std.hpp
)

=== src/settingsgen/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

if (NOT HOST_BINARY_DIR)
    project(settingsgen)

    set(sourcefiles
            settingsgen.cpp
            ../core/alloc_func.cpp
            ../misc/getoptdata.cpp
            ../ini_load.cpp
            ../string.cpp
    )
    add_definitions(-DSETTINGSGEN)
    add_executable(settingsgen ${sourcefiles})

    export(TARGETS settingsgen FILE ${CMAKE_BINARY_DIR}/settingsgen.cmake)
    add_dependencies(tools settingsgen)
endif()

=== src/strgen/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

if (NOT HOST_BINARY_DIR)
    project(strgen)

    set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../../cmake")

    set(sourcefiles
            strgen.cpp
            strgen_base.cpp
            ../core/alloc_func.cpp
            ../misc/getoptdata.cpp
            ../string.cpp
    )
    add_definitions(-DSTRGEN)
    add_executable(strgen ${sourcefiles})

    include(Endian)
    add_endian_definition()

    export(TARGETS strgen FILE ${CMAKE_BINARY_DIR}/strgen.cmake)
    add_dependencies(tools strgen)
endif()

if(OPTION_TOOLS_ONLY)
    return()
endif()

# Source Files
add_files(strgen_base.cpp)

# Header Files
add_files(strgen.h)

=== src/3rdparty/md5/CMakeLists.txt ===
add_files(
    md5.cpp
    md5.h
)

=== src/3rdparty/os2/CMakeLists.txt ===
add_files(
    getaddrinfo.c
    getaddrinfo.h
    getnameinfo.c
    getnameinfo.h
    CONDITION OPTION_OS2
)

=== src/os/macosx/CMakeLists.txt ===
add_files(
    crashlog_osx.cpp
    font_osx.cpp
    font_osx.h
    macos.h
    macos.mm
    osx_stdafx.h
    string_osx.cpp
    string_osx.h
    CONDITION APPLE
)

=== src/os/unix/CMakeLists.txt ===
add_files(
    crashlog_unix.cpp
    CONDITION UNIX AND NOT APPLE AND NOT OPTION_OS2
)

add_files(
    unix.cpp
    CONDITION UNIX AND NOT OPTION_OS2
)

add_files(
    font_unix.cpp
    CONDITION Fontconfig_FOUND
)

=== src/os/windows/CMakeLists.txt ===
add_files(
    crashlog_win.cpp
    font_win32.cpp
    font_win32.h
    string_uniscribe.cpp
    string_uniscribe.h
    win32.cpp
    win32.h
    CONDITION WIN32
)

=== debian/changelog ===
openttd (13.0-2) unstable; urgency=medium

  * [c3e16af] Fix cross-compilation by building build-time tools in a
    separate pass. Thanks to Helmut Grohne for the initial patch. (Closes:
    #1020921)

 -- Matthijs Kooijman <matthijs@stdin.nl>  Sun, 19 Feb 2023 15:38:12 +0100

openttd (13.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * [521c8eb] Remove constraints unnecessary since buster

  [ Matthijs Kooijman ]
  * [8805ef2] New upstream release 13.0
  * [56910c6] Bump standards version to 4.6.2 (no changes required)
  * [866fa62] Use new libfreetype-dev name in build-depends

 -- Matthijs Kooijman <matthijs@stdin.nl>  Wed, 15 Feb 2023 18:46:13 +0100

=== debian/control ===
Source: openttd
Section: games
Priority: optional
Maintainer: Matthijs Kooijman <matthijs@stdin.nl>
Uploaders: Jordi Mallach <jordi@debian.org>
Build-Depends: debhelper-compat (= 13), libsdl2-dev, zlib1g-dev, libpng-dev,
 libfreetype-dev, libfontconfig-dev, libicu-dev, liblzo2-dev, liblzma-dev,
 libfluidsynth-dev, libopengl-dev,
 grfcodec, openttd-opengfx,
 cmake
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/openttd-team/openttd
Vcs-Git: https://salsa.debian.org/openttd-team/openttd.git
Homepage: https://www.openttd.org/
Rules-Requires-Root: no

Package: openttd
Architecture: any
Multi-Arch: no
Depends: ${shlibs:Depends}, ${misc:Depends}, openttd-data (= ${source:Version})
Recommends: openttd-opengfx, openttd-openmsx, openttd-opensfx
Suggests: timidity
Description: reimplementation of Transport Tycoon Deluxe with enhancements
 OpenTTD is a reimplementation of the Microprose game "Transport
 Tycoon Deluxe" with lots of new features and enhancements.
 .
 OpenTTD is playable with the free graphics files from the openttd-opengfx
 package and optional sound and music files from the openttd-opensfx and
 openttd-openmsx packages Alternatively, OpenTTD can use the graphics files
 from the original Transport Tycoon Deluxe game (See README.Debian on how to set
 this up).

Package: openttd-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: common data files for the OpenTTD game
 This package contains data files like language files, scripts and some
 auxiliary graphics.  It does not include any full graphics or sound sets,
 which still need to be installed separately to play OpenTTD.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Makefile to build the openttd debian package.

include /usr/share/dpkg/architecture.mk

# Use debhelper default for all targets (but some are overridden below).
%:
	dh $@ --buildsystem=cmake

# This prevents linking uselessly to libicudata and silences a warning
# in the build process.
export DEB_LDFLAGS_MAINT_APPEND=-Wl,-as-needed

# Enable all hardening options (since openttd offers a network-listening
# service that handles untrusted data).
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Build release
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_BUILD_TYPE=RelWithDebInfo
# Explicitly mark dependencies as required or disabled, so an issue with
# build dependencies does not silently remove a feature or add a
# dependency
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_ZLIB=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_LibLZMA=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_LZO=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_PNG=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_Freetype=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_SDL2=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_Fontconfig=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_ICU=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_Grfcodec=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_Fluidsynth=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_OpenGL=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_DISABLE_FIND_PACKAGE_Allegro=TRUE

# When crosscompiling, prebuild tools that need to run on the build
# machine in a different build directory, and pass that build directory
# to the regular build so it can use those brebuilt ones.
ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
TOOLS_DIR=$(CURDIR)/build-native
CMAKE_CONFIG_ARGUMENTS += "-DHOST_BINARY_DIR=$(TOOLS_DIR)"
endif

# Pass custom options to configure. Since it's not autoconf but a custom
# script, some of the option names are slightly different. We also need
# to be explicit about the dependencies, in case we're not running in a
# clean build root.
override_dh_auto_configure:
ifneq ($(TOOLS_DIR),)
	dpkg-architecture -a"$(DEB_BUILD_ARCH)" -f -c dh_auto_configure -B"$(TOOLS_DIR)" -- -DOPTION_TOOLS_ONLY=ON
endif
	dh_auto_configure -- $(CMAKE_CONFIG_ARGUMENTS)

override_dh_auto_build:
ifneq ($(TOOLS_DIR),)
	dpkg-architecture -a"$(DEB_BUILD_ARCH)" -f -c dh_auto_build -B"$(TOOLS_DIR)"
endif
	dh_auto_build

execute_after_dh_install-arch:
	# Prevent installing duplicate license file
	rm debian/openttd/usr/share/doc/openttd/COPYING.md

GRF=media/baseset/openttd.grf
GRF_BACKUP=debian/openttd.grf

execute_before_dh_auto_build:
	# Remove the prebuilt grf file, to force a rebuild from source
	# (but do keep a backup, so the clean rule can restore it as
	# required by the policy).
	[ -f "$(GRF_BACKUP)" ] || mv "$(GRF)" "$(GRF_BACKUP)"

execute_after_dh_auto_clean:
	[ ! -f "$(GRF_BACKUP)" ] || mv "$(GRF_BACKUP)" "$(GRF)"

## openttd 13.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 endif()
 
 project(${BINARY_NAME}
-    VERSION 13.0
+    VERSION 13.4
 )
 
 if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
@@ -280,6 +280,8 @@
     endif()
 endif()
 
+include(CheckAtomic)
+
 if(APPLE)
     link_package(Iconv TARGET Iconv::Iconv)

=== bin/ai/CMakeLists.txt ===
set(AI_COMPAT_SOURCE_FILES
	${CMAKE_CURRENT_SOURCE_DIR}/compat_0.7.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.0.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.1.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.2.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.3.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.4.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.5.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.6.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.7.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.8.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.9.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.10.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.11.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_12.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_13.nut
)

foreach(AI_COMPAT_SOURCE_FILE IN LISTS AI_COMPAT_SOURCE_FILES)
    string(REPLACE "${CMAKE_SOURCE_DIR}/bin/" "" AI_COMPAT_SOURCE_FILE_NAME "${AI_COMPAT_SOURCE_FILE}")
    string(CONCAT AI_COMPAT_BINARY_FILE "${CMAKE_BINARY_DIR}/" "${AI_COMPAT_SOURCE_FILE_NAME}")

    add_custom_command(OUTPUT ${AI_COMPAT_BINARY_FILE}
            COMMAND ${CMAKE_COMMAND} -E copy
                    ${AI_COMPAT_SOURCE_FILE}
                    ${AI_COMPAT_BINARY_FILE}
            MAIN_DEPENDENCY ${AI_COMPAT_SOURCE_FILE}
            COMMENT "Copying ${AI_COMPAT_SOURCE_FILE_NAME}"
    )

    list(APPEND AI_COMPAT_BINARY_FILES ${AI_COMPAT_BINARY_FILE})
endforeach()

# Create a new target which copies all compat files
add_custom_target(ai_compat_files
        DEPENDS ${AI_COMPAT_BINARY_FILES}
)

add_dependencies(openttd
    ai_compat_files
)

=== bin/game/CMakeLists.txt ===
set(GS_COMPAT_SOURCE_FILES
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.2.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.3.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.4.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.5.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.6.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.7.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.8.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.9.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.10.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.11.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_12.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_13.nut
)

foreach(GS_COMPAT_SOURCE_FILE IN LISTS GS_COMPAT_SOURCE_FILES)
    string(REPLACE "${CMAKE_SOURCE_DIR}/bin/" "" GS_COMPAT_SOURCE_FILE_NAME "${GS_COMPAT_SOURCE_FILE}")
    string(CONCAT GS_COMPAT_BINARY_FILE "${CMAKE_BINARY_DIR}/" "${GS_COMPAT_SOURCE_FILE_NAME}")

    add_custom_command(OUTPUT ${GS_COMPAT_BINARY_FILE}
            COMMAND ${CMAKE_COMMAND} -E copy
                    ${GS_COMPAT_SOURCE_FILE}
                    ${GS_COMPAT_BINARY_FILE}
            MAIN_DEPENDENCY ${GS_COMPAT_SOURCE_FILE}
            COMMENT "Copying ${GS_COMPAT_SOURCE_FILE_NAME}"
    )

    list(APPEND GS_COMPAT_BINARY_FILES ${GS_COMPAT_BINARY_FILE})
endforeach()

# Create a new target which copies all compat files
add_custom_target(gs_compat_files
        DEPENDS ${GS_COMPAT_BINARY_FILES}
)

add_dependencies(openttd
    gs_compat_files
)

=== src/core/CMakeLists.txt ===
add_files(
    alloc_func.cpp
    alloc_func.hpp
    alloc_type.hpp
    backup_type.hpp
    bitmath_func.cpp
    bitmath_func.hpp
    endian_func.hpp
    endian_type.hpp
    enum_type.hpp
    geometry_func.cpp
    geometry_func.hpp
    geometry_type.hpp
    kdtree.hpp
    math_func.cpp
    math_func.hpp
    mem_func.hpp
    multimap.hpp
    overflowsafe_type.hpp
    pool_func.cpp
    pool_func.hpp
    pool_type.hpp
    random_func.cpp
    random_func.hpp
    smallmap_type.hpp
    smallmatrix_type.hpp
    smallstack_type.hpp
    smallvec_type.hpp
    span_type.hpp
    string_compare_type.hpp
    strong_typedef_type.hpp
)

=== src/lang/CMakeLists.txt ===
set(MASTER_LANG_FILE
        ${CMAKE_CURRENT_SOURCE_DIR}/english.txt
)

set(LANG_SOURCE_FILES
        ${MASTER_LANG_FILE}
        ${CMAKE_CURRENT_SOURCE_DIR}/afrikaans.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/arabic_egypt.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/basque.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/belarusian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/brazilian_portuguese.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/bulgarian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/catalan.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/chuvash.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/croatian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/czech.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/danish.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/dutch.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/english_AU.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/english_US.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/esperanto.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/estonian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/faroese.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/finnish.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/french.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/frisian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/gaelic.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/galician.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/german.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/greek.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/hebrew.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/hindi.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/hungarian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/icelandic.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/ido.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/indonesian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/irish.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/italian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/japanese.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/korean.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/latin.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/latvian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/lithuanian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/luxembourgish.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/macedonian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/malay.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/maltese.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/marathi.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/norwegian_bokmal.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/norwegian_nynorsk.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/persian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/polish.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/portuguese.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/romanian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/russian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/serbian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/simplified_chinese.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/slovak.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/slovenian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/spanish.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/spanish_MX.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/swedish.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/tamil.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/thai.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/traditional_chinese.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/turkish.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/urdu.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/ukrainian.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/vietnamese.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/welsh.txt
)

set(LANG_BINARY_DIR ${CMAKE_BINARY_DIR}/lang)

if (HOST_BINARY_DIR)
    include(${HOST_BINARY_DIR}/strgen.cmake)
endif()

# Walk over all the (finished) language files, and generate a command to compile them
foreach(LANG_SOURCE_FILE IN LISTS LANG_SOURCE_FILES)
    get_filename_component(LANG_SOURCE_FILE_NAME_WE ${LANG_SOURCE_FILE} NAME_WE)

    set(LANG_BINARY_FILE ${LANG_BINARY_DIR}/${LANG_SOURCE_FILE_NAME_WE}.lng)

    add_custom_command(OUTPUT ${LANG_BINARY_FILE}
            COMMAND ${CMAKE_COMMAND} -E make_directory ${LANG_BINARY_DIR}
            COMMAND strgen
                    -s ${CMAKE_CURRENT_SOURCE_DIR}
                    -d ${LANG_BINARY_DIR}
                    ${LANG_SOURCE_FILE}
            DEPENDS strgen ${MASTER_LANG_FILE}
            MAIN_DEPENDENCY ${LANG_SOURCE_FILE}
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            COMMENT "Compiling language ${LANG_SOURCE_FILE_NAME_WE}"
    )

    list(APPEND LANG_BINARY_FILES ${LANG_BINARY_FILE})
endforeach()

# Create a new target which compiles all language files
add_custom_target(language_files
        DEPENDS
        ${LANG_BINARY_FILES}
)
set_target_properties(language_files
        PROPERTIES LANG_SOURCE_FILES "${LANG_SOURCE_FILES}"
)


set(GENERATED_BINARY_DIR ${CMAKE_BINARY_DIR}/generated)
set(TABLE_BINARY_DIR ${GENERATED_BINARY_DIR}/table)

# Generate a command and target to create the strings table
add_custom_command_timestamp(OUTPUT ${TABLE_BINARY_DIR}/strings.h
        COMMAND ${CMAKE_COMMAND} -E make_directory ${TABLE_BINARY_DIR}
        COMMAND strgen
                -s ${CMAKE_CURRENT_SOURCE_DIR}
                -d ${TABLE_BINARY_DIR}
        DEPENDS strgen ${MASTER_LANG_FILE}
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating table/strings.h"
)
add_custom_target_timestamp(table_strings
        DEPENDS
        ${TABLE_BINARY_DIR}/strings.h
)

add_library(languages
        INTERFACE
)
target_include_directories(languages
        INTERFACE
        ${GENERATED_BINARY_DIR}
)
add_dependencies(languages
        language_files
        table_strings
)
add_library(openttd::languages ALIAS languages)

=== src/pathfinder/CMakeLists.txt ===
add_subdirectory(npf)
add_subdirectory(yapf)

add_files(
    follow_track.hpp
    pathfinder_func.h
    pathfinder_type.h
)

=== src/saveload/CMakeLists.txt ===
add_subdirectory(compat)

add_files(
    afterload.cpp
    ai_sl.cpp
    airport_sl.cpp
    animated_tile_sl.cpp
    autoreplace_sl.cpp
    cargomonitor_sl.cpp
    cargopacket_sl.cpp
    cheat_sl.cpp
    company_sl.cpp
    depot_sl.cpp
    economy_sl.cpp
    engine_sl.cpp
    game_sl.cpp
    gamelog_sl.cpp
    goal_sl.cpp
    group_sl.cpp
    industry_sl.cpp
    labelmaps_sl.cpp
    league_sl.cpp
    linkgraph_sl.cpp
    map_sl.cpp
    misc_sl.cpp
    newgrf_sl.cpp
    newgrf_sl.h
    object_sl.cpp
    oldloader.cpp
    oldloader.h
    oldloader_sl.cpp
    order_sl.cpp
    saveload.cpp
    saveload.h
    saveload_filter.h
    saveload_internal.h
    settings_sl.cpp
    signs_sl.cpp
    station_sl.cpp
    storage_sl.cpp
    strings_sl.cpp
    story_sl.cpp
    subsidy_sl.cpp
    town_sl.cpp
    vehicle_sl.cpp
    waypoint_sl.cpp
)

=== src/widgets/CMakeLists.txt ===
add_files(
    ai_widget.h
    airport_widget.h
    autoreplace_widget.h
    bootstrap_widget.h
    bridge_widget.h
    build_vehicle_widget.h
    cheat_widget.h
    company_widget.h
    console_widget.h
    date_widget.h
    depot_widget.h
    dock_widget.h
    dropdown.cpp
    dropdown_func.h
    dropdown_type.h
    dropdown_widget.h
    engine_widget.h
    error_widget.h
    fios_widget.h
    framerate_widget.h
    game_widget.h
    genworld_widget.h
    goal_widget.h
    graph_widget.h
    group_widget.h
    highscore_widget.h
    industry_widget.h
    intro_widget.h
    league_widget.h
    link_graph_legend_widget.h
    main_widget.h
    misc_widget.h
    music_widget.h
    network_chat_widget.h
    network_content_widget.h
    network_widget.h
    newgrf_debug_widget.h
    newgrf_widget.h
    news_widget.h
    object_widget.h
    order_widget.h
    osk_widget.h
    rail_widget.h
    road_widget.h
    screenshot_widget.h
    settings_widget.h
    sign_widget.h
    slider.cpp
    slider_func.h
    smallmap_widget.h
    station_widget.h
    statusbar_widget.h
    story_widget.h
    subsidy_widget.h
    terraform_widget.h
    timetable_widget.h
    toolbar_widget.h
    town_widget.h
    transparency_widget.h
    tree_widget.h
    vehicle_widget.h
    viewport_widget.h
    waypoint_widget.h
)

=== src/3rdparty/squirrel/CMakeLists.txt ===
add_subdirectory(include)
add_subdirectory(sqstdlib)
add_subdirectory(squirrel)

=== src/network/core/CMakeLists.txt ===
add_files(
    address.cpp
    address.h
    config.cpp
    config.h
    core.cpp
    core.h
    game_info.cpp
    game_info.h
    host.cpp
    host.h
    os_abstraction.cpp
    os_abstraction.h
    packet.cpp
    packet.h
    tcp.cpp
    tcp.h
    tcp_admin.cpp
    tcp_admin.h
    tcp_connect.cpp
    tcp_content.cpp
    tcp_content.h
    tcp_content_type.h
    tcp_coordinator.cpp
    tcp_coordinator.h
    tcp_game.cpp
    tcp_game.h
    tcp_http.cpp
    tcp_http.h
    tcp_listen.h
    tcp_stun.cpp
    tcp_stun.h
    tcp_turn.cpp
    tcp_turn.h
    udp.cpp
    udp.h
)

=== src/pathfinder/yapf/CMakeLists.txt ===
add_files(
    nodelist.hpp
    yapf.h
    yapf.hpp
    yapf_base.hpp
    yapf_cache.h
    yapf_common.hpp
    yapf_costbase.hpp
    yapf_costcache.hpp
    yapf_costrail.hpp
    yapf_destrail.hpp
    yapf_node.hpp
    yapf_node_rail.hpp
    yapf_node_road.hpp
    yapf_node_ship.hpp
    yapf_rail.cpp
    yapf_road.cpp
    yapf_ship.cpp
    yapf_type.hpp
)

=== src/video/cocoa/CMakeLists.txt ===
add_files(
    cocoa_keys.h
    cocoa_v.h
    cocoa_v.mm
    cocoa_wnd.h
    cocoa_wnd.mm
    CONDITION APPLE
)

add_files(
    cocoa_ogl.h
    cocoa_ogl.mm
    CONDITION APPLE AND OPENGL_FOUND
)

=== debian/changelog ===
openttd (13.4-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:03:42 +1100

openttd (13.4-1build2) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 07:46:23 +0000

openttd (13.4-1build1) noble; urgency=medium

  * No-change rebuild for ICU soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 11:07:38 +0100

openttd (13.4-1) unstable; urgency=medium

  * [72a0233] New upstream release 13.4 (Closes: #1053950, #1032180)

 -- Matthijs Kooijman <matthijs@stdin.nl>  Sat, 25 Nov 2023 18:04:32 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: openttd
 Section: games
 Priority: optional
-Maintainer: Matthijs Kooijman <matthijs@stdin.nl>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matthijs Kooijman <matthijs@stdin.nl>
 Uploaders: Jordi Mallach <jordi@debian.org>
 Build-Depends: debhelper-compat (= 13), libsdl2-dev, zlib1g-dev, libpng-dev,
  libfreetype-dev, libfontconfig-dev, libicu-dev, liblzo2-dev, liblzma-dev,
